#include "cid.h"

void inicia_fat()
{
	int i;
	fat[0] = -1;
	fat[1] = -1;
	for (i = 2; i < TAM_TAB_FAT(TIPO_FAT) - 1; i++)
		fat[i] = i + 1;
	fat[i] = -1;
	
	bfd[bfdid].tipo = TIPO_BFD;
	bfd[bfdid].tamanho = 0;
	bfd[bfdid].primeiro_bloco = 0;
	
	bfd[++bfdid].tipo = TIPO_DIRETORIO;
	bfd[bfdid].tamanho = 1;
	bfd[bfdid].primeiro_bloco = 1;
	
	bfd[++bfdid].tipo = TIPO_DIRETORIO;
	bfd[bfdid].tamanho = 1;
	bfd[bfdid].primeiro_bloco = 2;
	
	bfd[++bfdid].tipo = TIPO_ARQUIVO;
	bfd[bfdid].tamanho = 1;
	bfd[bfdid].primeiro_bloco = 3; /* endereco na fat */
	/*
	bloco[0].index=2;
	strcpy(bloco[0].nome, "windows\0");
	
	bloco[1].index=3;
	strcpy(bloco[1].nome, "temp\0"); */
}

void *driver(void)
{
	int status=0;
	
	BUFFER_REQUISICAO buffer_requisicao;
	REQUISICAO *requisicao = (REQUISICAO *)(buffer_requisicao.mtext);
	
	while(1)
	{
		/* REQUISICAO  da CID*/
		if(msgrcv(msg_cid,(struct msgbuf *)&buffer_requisicao,sizeof(REQUISICAO),1,0) == -1 )
		{
			fprintf(stderr, "Impossivel receber mensagem!\n");
			exit(1);
		}
		fprintf(stderr, "\n Driver escutando: operacao=%d", requisicao->operacao);
		switch(requisicao->operacao)
		{
			case 1:{
				// consulta bfd e retorna o bloco
			}
			
			case 2:{
				// consulta fat 
			}
		}
		usleep(100000);
		/* REPOSTA PARA a CID*/
		BUFFER_RESPOSTA buffer_resposta;
		buffer_resposta.mtype=1;
		buffer_resposta.mtext[0] = '2';
		if( msgsnd(msg_cid,(struct msgbuf *)&buffer_resposta, 1,0) ==-1 )
		{
			fprintf(stderr, "Impossivel enviar mensagem de resposta!\n");
			exit(1);
		}
		fprintf(stderr, "\n Driver enviando resposta: %c", buffer_resposta.mtext[0]);
		
	}
	pthread_exit(NULL);
}
	

int main(int argc, char *argv[])
{	
	if(argc < 2)
		return -1;
	
	
	/* Cria a fila de mensagens que sera usada na comunicacao com o Driver, modo 0666 significa que 
	qualquer um pode ler e escrever nessa fila.  */
	if( (msg_cid = msgget(MSG_CID, IPC_CREAT | 0666)) == -1 )
	{
		fprintf(stderr,"\n Impossivel criar fila de mensagem");
		exit(1);
	}
	
	/* Cria e inicia as Memorias compartilhadas:  BFD, Lista de aruqivos abertos e PCBs */
	if((shm_listaaa=shmget(SHM_LISTAAA,(NUMERO_MAGICO * sizeof(LISTAAA)),IPC_CREAT | 0666))==-1)
		fprintf(stderr,"\nerro criar mem share listaaa\n");
	if((listaaa=(LISTAAA *) shmat(shm_listaaa, NULL, 0))==(LISTAAA *) -1)
		fprintf(stderr,"\nerro ao iniciar mem share listaaa");
	
	if((shm_bfd=shmget(SHM_BFD,NUMERO_MAGICO * sizeof(BFD),IPC_CREAT | 0666))==-1)
		fprintf(stderr,"\nerro criar mem share BFD\n");
	if((bfd=(BFD *) shmat(shm_bfd, NULL, 0))==(BFD *) -1)
		fprintf(stderr,"\nerro ao iniciar mem share bfd");
	
	if((shm_pcb=shmget(SHM_PCB,sizeof(PCB),IPC_CREAT | 0666))==-1)
		fprintf(stderr,"\nerro criar mem share PCB\n");
	if((pcb=(PCB *) shmat(shm_pcb, NULL, 0))==(PCB *) -1)
		fprintf(stderr,"\nerro ao iniciar mem share pcb");
	
	sem_listaaa = semget(SEM_LISTAAA,1,0666|IPC_CREAT);
	
	inicia_fat();	/* preenche com dados ficticios a bfd e a fat (plano de testes) */
	
	/* Thread do driver*/
	if(pthread_create(&DRIVER_T, NULL, (void *)driver, NULL))
		fprintf(stderr,"ERRO: impossivel criar um thread driver\n");
	ffopen(argv[1], 1);
	
	pcb->pid = getpid();

	//printf("%\n path = %s", filename);

}
